using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;
using Infragistics.Win.CalcEngine;
using Infragistics.Win.UltraWinCalcManager;

namespace WindowsApplication15
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // Add a simple summary to column 0.
            e.Layout.Bands[0].Summaries.Add( SummaryType.Sum, e.Layout.Bands[0].Columns["Column 0"]);
        }

        private void ultraGrid2_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            // Add a simple summary to column 0.
            e.Layout.Bands[0].Summaries.Add(SummaryType.Sum, e.Layout.Bands[0].Columns["Column 0"]);
            
            // Add a summary that sums up both summaries using an ICustomerSummaryCalculator
            e.Layout.Bands[0].Summaries.Add(
                SummaryType.Custom,
                new MySummaryCalculator(this.ultraGrid1), 
                e.Layout.Bands[0].Columns["Column 0"], 
                SummaryPosition.UseSummaryPositionColumn,
                e.Layout.Bands[0].Columns["Column 0"]
                );
       }
    }

    public class MySummaryCalculator : ICustomSummaryCalculator
    {
        // The ICustomSummaryCalculator needs a reference to the other grid so we
        // can get the value of it's summary. 
        private UltraGrid otherGrid;

        public MySummaryCalculator(UltraGrid otherGrid)
        {
            this.otherGrid = otherGrid;
        }

        #region ICustomSummaryCalculator Members

        public void BeginCustomSummary(SummarySettings summarySettings, RowsCollection rows)
        {
            // Don't need to do anything here. 
        }

        public void AggregateCustomSummary(SummarySettings summarySettings, UltraGridRow row)
        {
            // Don't need to do anything here. 
        }

        public object EndCustomSummary(SummarySettings summarySettings, RowsCollection rows)
        {
            // I'm using index 0 here into the 
            // the SummaryValues collection. But in a real app, I would probably want to build
            // the Key of the summaries in each grid based on the summarySettings.SourceColumn. 

            // Get the value of the summary in this rows collection.
            decimal mySummaryValue = (decimal)rows.SummaryValues[0].Value;

            // Get the sumary value from the other grid. 
            decimal otherGridSummary = (decimal)this.otherGrid.Rows.SummaryValues[0].Value;
            return mySummaryValue + otherGridSummary;
            
        }

        #endregion
    }
}